package com.zhongzheng.modules.base.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.base.bo.SmsAddBo;
import com.zhongzheng.modules.base.bo.SmsEditBo;
import com.zhongzheng.modules.base.bo.SmsQueryBo;
import com.zhongzheng.modules.base.domain.Sms;
import com.zhongzheng.modules.base.mapper.SmsMapper;
import com.zhongzheng.modules.base.service.ISmsService;
import com.zhongzheng.modules.base.vo.SmsVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 短信Service业务层处理
 *
 * @author hjl
 * @date 2021-11-26
 */
@Service
public class SmsServiceImpl extends ServiceImpl<SmsMapper, Sms> implements ISmsService {

    @Override
    public SmsVo queryById(Long id){
        Sms db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, SmsVo.class);
    }

    @Override
    public List<SmsVo> queryList(SmsQueryBo bo) {
        LambdaQueryWrapper<Sms> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getTel()), Sms::getTel, bo.getTel());
        lqw.eq(StrUtil.isNotBlank(bo.getCode()), Sms::getCode, bo.getCode());
        lqw.eq(bo.getType() != null, Sms::getType, bo.getType());
        lqw.eq(StrUtil.isNotBlank(bo.getIp()), Sms::getIp, bo.getIp());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<SmsVo> entity2Vo(Collection<Sms> collection) {
        List<SmsVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, SmsVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<Sms> page = (Page<Sms>)collection;
            Page<SmsVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(SmsAddBo bo) {
        Sms add = BeanUtil.toBean(bo, Sms.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(SmsEditBo bo) {
        Sms update = BeanUtil.toBean(bo, Sms.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Sms entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
